import processing.opengl.*;
import org.jklabs.easyosc.*;

EasyOsc osc;
float[] vals;

color bass = color(255,55,0);
color treble = color(0,195,255);
color bright = color(255,255,255);

void setup() {
  osc = new EasyOsc(this,"spectrum");
  size(500,200,OPENGL);
  setBars(20);
}

void setBars(int nBars) {
  vals = new float[nBars];
}

void setVals(float[] newVals) {
  vals = newVals;
}

void draw() {
  background(20);
  stroke(20);
  fill(80);
  scale(1,-1);
  translate(0,-height);
  //rotateX(radians(-30));
  int w = width/vals.length;
  int x = 0;
  int y = 0;
  for (int i=0; i<vals.length; i++) {
    color c = lerpColor(bass,treble,i/(float)vals.length);
    c = lerpColor(c,bright,vals[i]/3);
    fill(c);
    rect(x, y, w, vals[i]*height);
    x+=w;
  }
}

